<?php
////////////////////////////////////////////////////////////////
//
// File:      FAST 3.2 (First Automatic Server for Trackmania)
// Web:       
// Date:      08.06.2008
// Author:    Gilles Masson
// Plugin:	  MCM
// -function: local records flatfile database
// -compat.:  >= FAST 3.2.0w
////////////////////////////////////////////////////////////////

registerPlugin('localdbf',100);
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// init the database
function localdbfInit($event)
{ 

global $localdbf_pinfos, $localdbf_scores, $localdbf_players,
	   $localdbf_pldb, $localdbf_chdb, $localdbf_redb, $localdbf_scdb, $localdbf_player_index,
	   $localdbf_maxtop, $localdbf_oldranking, $localdbf_joinmsg, $localdbf_update_ranking_logins, $localdbf_is_glider,
	   $localdbf_main_xml, $localdbf_config, $localdbf_update_ranking, $localdbf_players_to_update, $localdbf_defshowrecs;

// check for glider plugin pack
if(function_exists('saInit')) $localdbf_is_glider = true;
	else $localdbf_is_glider = false;
// load the configuration
localdbf_loadconfig();

$localdbf_players_to_update = array();
//manialinks
	
	$localdbf_main_xml = '';
	manialinksAddAction('localdbf_main.up');
	manialinksAddAction('localdbf_main.down');
	manialinksAddAction('localdbf_recs.open');
	manialinksAddAction('localdbf_recs.next');
	manialinksAddAction('localdbf_recs.back');
	manialinksAddAction('localdbf_top.open');
	manialinksAddAction('localdbf_top.next');
	manialinksAddAction('localdbf_top.back');
	manialinksAddAction('localdbf_admin.open');
	manialinksAddAction('localdbf_confirm.yes');
	manialinksAddAction('localdbf_confirm.no');
	
	manialinksAddId('localdbf_main');
	manialinksAddId('localdbf_recs');
	manialinksAddId('localdbf_top');
	manialinksAddId('localdbf_admin');
	manialinksAddId('localdbf_confirm');
 
//load the db system
 include ("./data/php-api/txt-db-api.php");
  $rootdb = new Database(ROOT_DATABASE);
// create dbs if neccessary
  if (!file_exists(DB_DIR . "players")) $rootdb->executeQuery("CREATE DATABASE players");
  if (!file_exists(DB_DIR . "records")) $rootdb->executeQuery("CREATE DATABASE records");
  if (!file_exists(DB_DIR . "challenges")) $rootdb->executeQuery("CREATE DATABASE challenges");
  if (!file_exists(DB_DIR . "scores")) $rootdb->executeQuery("CREATE DATABASE scores");
  
// activate dbs
	$localdbf_pldb = new Database("players");
	$localdbf_chdb = new Database("challenges");
	$localdbf_redb = new Database("records");
	$localdbf_scdb = new Database("scores");
	
	//this is the players table
	$player_file='players/local_players.txt';
	$update_player_file='players/update-local_players.txt';
	
//create new table if neccessary
	if (!file_exists(DB_DIR . $player_file)) 
	{
	$localdbf_pldb->executeQuery("CREATE TABLE local_players (
				   					Login str DEFAULT '',
				   					NickName str DEFAULT '',
				   					Nation str DEFAULT 'def',
				   					TimePlayed int DEFAULT '0',
				   					LastSeen str DEFFAULT '',
				   					PlayerPowers int DEFAULT '0',
				 					ShowRecs int DEFAULT '$localdbf_defshowrecs',
				 					ShowInfo int DEFAULT '21')");
	}	
	//this are the player scores overall
	$score_file='scores/local_scores.txt';
	$update_score_file = 'scores/old-local_scores.txt';
//create new table if neccessary
	if (!file_exists(DB_DIR . $score_file)) 
	{
	$localdbf_scdb->executeQuery("CREATE TABLE local_scores (
 									Login str DEFAULT '',
				   					Wins int DEFAULT '0',
				   					Score int DEFAULT '0')");
	
	// for first run migrate the scores from recordfiles
	$result = $localdbf_redb->executeQuery("LIST TABLES");
	$records_tracks = localdbf_GetArray($result);
	if(isset($records_tracks[0]))
	{
	$localdbf_player_index = array();
		 	
			 print_r('-->Local: Recalculating scores ');

	foreach($records_tracks as $track)
	{	
	 	$table = $track['table'];
	 	print_r('.');
		$result = $localdbf_redb->executeQuery("SELECT * FROM $table
												 WHERE PlayerTime > '0'	
											 	 ORDER BY PlayerTime DESC");
		$records = localdbf_GetArray($result);
		$counter = count($records);
		
		if($counter > 0)
			{			
				for($i=0; $i < $counter; $i++)
					{
						$playerlogin = $records[$i]['PlayerLogin'];
						$score = $i;
						if(in_array($playerlogin,$localdbf_player_index))
						{
							$currentscore = $localdbf_scores[$playerlogin]['Score'];
							if($i < $localdbf_maxtop){
							$nextscore = $currentscore + $score;
							}
							else{
							$nextscore = $currentscore;
							}
							$localdbf_scores[$playerlogin]['Login'] = $playerlogin;
							$localdbf_scores[$playerlogin]['Score'] = $nextscore;
						}
						else
						{
						if($i < $localdbf_maxtop){
						$localdbf_scores[$playerlogin]['Score'] = $score;
						}
						else{
						$localdbf_scores[$playerlogin]['Score'] = 0;
						}
						$localdbf_scores[$playerlogin]['Login'] = $playerlogin;
						array_push($localdbf_player_index,$playerlogin);
						}
					}
			}
		
	} // end migration of scores
	//save the scores into new score table and generate new playertable
	print_r('Done !!'."\n");
	$i=1;
	print_r('-->Local : Loading players.....');
	$result = $localdbf_pldb->executeQuery("SELECT * FROM local_players");
	$localdbf_players_toload = localdbf_GetArray($result);
	
	foreach($localdbf_players_toload as $player)
		{
			$playerlogin = $player['Login'];
			if($player['ShowInfo'] < 11) $playershowinfo = 21;
			else $playershowinfo = $player['ShowInfo'];
			$localdbf_players[$playerlogin]['Login']= $playerlogin;
			$localdbf_players[$playerlogin]['NickName']=$player['NickName'];
			$localdbf_players[$playerlogin]['Nation']=$player['Nation'];
			$localdbf_players[$playerlogin]['LastSeen']=$player['LastSeen'];
			$localdbf_players[$playerlogin]['TimePlayed']=$player['TimePlayed'];
			$localdbf_players[$playerlogin]['PlayerPowers']=$player['PlayerPowers'];
			$localdbf_players[$playerlogin]['ShowRecs']=$player['ShowRecs'];
			$localdbf_players[$playerlogin]['OldShowRecs'] = 0;
			$localdbf_players[$playerlogin]['ShowInfo']=$playershowinfo;
		print_r('.');	
		}
		print_r('Done !!'."\n");
		if(file_exists(DB_DIR . $update_score_file)){
		print_r('-->Local : Loading old scores.....');
	$result = $localdbf_scdb->executeQuery("SELECT * FROM old-local_scores");
	$localdbf_scores_toload = localdbf_GetArray($result);
	$localdbf_player_index = array();
if(isset($localdbf_scores_toload[0]))
 {	
	foreach($localdbf_scores_toload as $player)
		{
			$playerlogin = $player['Login'];
			array_push($localdbf_player_index,$playerlogin);
			$localdbf_scores[$playerlogin]['Login']= $playerlogin;
			$localdbf_scores[$playerlogin]['Wins']=$player['Wins'];
			$localdbf_scores[$playerlogin]['Score']=$player['Score'];
		}
print_r('...Done !!'."\n");
}
}
	print_r('-->Local: Creating Players and Scores ');
		foreach($localdbf_scores as $player)
		{
			$playerlogin = $player['Login'];
			$playerscore = $player['Score'];
			$wins = 0;
			if(isset($player['Wins'])) $wins = $player['Wins'];
			
			$localdbf_scdb->executeQuery("INSERT INTO local_scores
											VALUES
											('$playerlogin', '$wins','$playerscore')");
			
			if(!isset($localdbf_players[$playerlogin])){
			$localdbf_pldb->executeQuery("INSERT INTO local_players
											VALUES
											('$playerlogin', '$playerlogin','def','0','','0','2','21')");
			}								
			// print_r('-->Player - '.$i.' - '.$playerlogin."\n");
			print_r('.');
			$i++;
		}
			print_r('Done !!'."\n");
	
	}
	}
// load the scores
print_r('-->Local : Loading scores.....');
	$result = $localdbf_scdb->executeQuery("SELECT * FROM local_scores");
	$localdbf_scores_toload = localdbf_GetArray($result);
	$localdbf_player_index = array();
if(isset($localdbf_scores_toload[0]))
 {	
	foreach($localdbf_scores_toload as $player)
		{
			$playerlogin = $player['Login'];
			array_push($localdbf_player_index,$playerlogin);
			$localdbf_scores[$playerlogin]['Login']= $playerlogin;
			$localdbf_scores[$playerlogin]['Wins']=$player['Wins'];
			$localdbf_scores[$playerlogin]['Score']=$player['Score'];
		}
print_r('...Done !!'."\n");
print_r('-->Local : Loading players.....');
	$result = $localdbf_pldb->executeQuery("SELECT * FROM local_players");
	$localdbf_players_toload = localdbf_GetArray($result);
	
	foreach($localdbf_players_toload as $player)
		{
			$playerlogin = $player['Login'];
			if($player['ShowInfo'] < 11) $playershowinfo = 21;
			else $playershowinfo = $player['ShowInfo'];
			$localdbf_players[$playerlogin]['Login']= $playerlogin;
			$localdbf_players[$playerlogin]['NickName']=$player['NickName'];
			$localdbf_players[$playerlogin]['Nation']=$player['Nation'];
			$localdbf_players[$playerlogin]['LastSeen']=$player['LastSeen'];
			$localdbf_players[$playerlogin]['TimePlayed']=$player['TimePlayed'];
			$localdbf_players[$playerlogin]['PlayerPowers']=$player['PlayerPowers'];
			$localdbf_players[$playerlogin]['ShowRecs']=$player['ShowRecs'];
			$localdbf_players[$playerlogin]['OldShowRecs'] = 0;
			$localdbf_players[$playerlogin]['ShowInfo']=$playershowinfo;
		print_r('.');	
		}
 }
print_r('...Done !!'."\n");
					


//////////////////////////////////////////////////////////////////////////////////////////////////////////////
global 	$localdbf_col1, $localdbf_col2, $_TracksDirectory;

$localdbf_col1 = '$z$i$ff9';
$localdbf_col2 = '$z$i$cff';

$localdbf_update_ranking_logins = array(); 
localdbfSortLadder();

}
// ** END INIT ** //

function localdbf_sqlesc($string)
{	
 	$string = stripLinks($string);
	$string = str_replace('"','\"',$string);
	$string = str_replace('\\','\\\\',$string);
	$string = str_replace('\'','\\\'',$string);
	return($string);
}
function localdbf_mlesc($string)
{
	$string = str_replace('"','',$string);
	$string = str_replace("\\",'',$string);
	return($string);
}

function localdbf_GetArray($resultset)
{
	$result = array();
	while($resultset->next())
	{
		$data = $resultset->getCurrentValuesAsHash();
		array_push($result, $data);
	}
	return($result);
}

function localdbf_saveconfig(){
	global $localdbf_config, $localdbf_maxtop, $localdbf_defshowrecs;
	
	$config['Localdbf.cfg'] = $localdbf_config;

			$configfile = './data/default.localdbf.cfg.xml';
			xml_build_to_file($config,$configfile);
}

function localdbf_loadconfig(){
	global $localdbf_config, $localdbf_maxtop, $localdbf_defshowrecs;	
	
	$localdbf_config = array('status' => 1,
						 'maxtop' => 100,
						 'defshowrecs' => 3, // possible 1, 3, 5, 10
						 'forceshowrecs' => 0,
						 'forceshowrecsmax' => 100,
						 'col1' => '$ff0', // yellow
						 'col2' => '$000', // black 
						 'col3' => '$f00', // red
						 'col4' => '$9f6', // green
						 'col5' => '$fc6', // yellowbrown
						 'col6' => '$03f'); // Blue
						 
$config['Localdbf.cfg'] = $localdbf_config;

			$configfile = './data/default.localdbf.cfg.xml';
			if(!file_exists($configfile))
			xml_build_to_file($config,$configfile);
			else{
			$config = xml_parse_file($configfile);
			$localdbf_config = $config['Localdbf.cfg'];
			}
// for comaptiblity with previous versions 
		if(!isset($localdbf_config['defshowrecs'])){
			$localdbf_config['defshowrecs'] = 3;
			localdbf_saveconfig();
			localdbf_loadconfig();
		}
		if(!isset($localdbf_config['forceshowrecs'])){
			$localdbf_config['forceshowrecs'] = 0;
			localdbf_saveconfig();
			localdbf_loadconfig();
		}
		if(!isset($localdbf_config['forceshowrecsmax'])){
			$localdbf_config['forceshowrecsmax'] = 100;
			localdbf_saveconfig();
			localdbf_loadconfig();
		}
		/////
		
$localdbf_maxtop = $localdbf_config['maxtop'];
	if($localdbf_defshowrecs == 1){
		$localdbf_config['defshowrecs'] = 1;
		return;
	}
	elseif($localdbf_defshowrecs == 2){
		$localdbf_config['defshowrecs'] = 3;
		return;
	}
	elseif($localdbf_defshowrecs == 3){
		$localdbf_config['defshowrecs'] = 5;
		return;
	}
	elseif($localdbf_defshowrecs == 4){
		$localdbf_config['defshowrecs'] = 10;
		return;
	}
	
	// setting default param and saving it in case wrong setting in config file
	$localdbf_defshowrecs = 2;
	$localdbf_config['defshowrecs'] = 3;
	localdbf_saveconfig();	
}

//////////////////////////////////////////////
//** player connecting and disconnecting **///
//////////////////////////////////////////////
function localdbf_player_local_connect($login)
{	global $_client, $_players, $localdbf_players, $localdbf_pldb, $localdbf_scdb, $localdbf_player_index, $localdbf_scores;

	$player = $_players[$login];
	$newnick=$player['NickName'];
	//$newnation = $player['Nation'];
	//if(!isset($newnation)) $newnation = 'err';
	$newnick = stripLinks($newnick);
	
	// initialize new player
	///////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	if(!in_array($login,$localdbf_player_index))
	{
	//insert new player in file
	
	$dbnick = localdbf_sqlesc($newnick);
	$localdbf_pldb->executeQuery("INSERT INTO local_players
							VALUES
				    	  ('$login','$dbnick','def','0',' ','0','2','1')");
	
	$localdbf_scdb->executeQuery("INSERT INTO local_scores
							VALUES
							('$login','0','0')");
	//array_push($localdbf_scores,array('Login' => $login, 'Wins' => 0, 'Score' => 0));
	$localdbf_scores[$login]=array('Login' => $login, 'Wins' => 0, 'Score' => 0);
	//insert playerdata in ram
	$localdbf_players[$login] = array('Login' => $login,
							   'NickName' => $newnick,
							   'Nation' => 'def',
							   'TimePlayed' => 0,
							   'LastSeen' => ' ',
							   'PlayerPowers' => 0,
							   'ShowRecs' => 2,
							   'OldShowRecs' => 0,
							   'ShowInfo' => 1);
							   
	$localdbf_players[$login]['join'] = time();
	$localdbf_players[$login]['join_score'] = 0;
	$localdbf_players[$login]['join_wins'] = 0;
	$localdbf_players[$login]['join_rank'] = 0;
	array_push($localdbf_player_index,$login);
	return;
	}

     $localdbf_players[$login]['join'] = time();
     $localdbf_players[$login]['join_wins'] = $localdbf_scores[$login]['Wins'];
     $localdbf_players[$login]['join_score'] = $localdbf_scores[$login]['Score'];
      
	  if($localdbf_players[$login]['Nation'] == '')
		  $localdbf_players[$login]['Nation'] = 'def';
	
     if($localdbf_players[$login]['Nation'] != 'def')
    	$_players[$login]['Language'] = $localdbf_players[$login]['Nation'];
     
     if(isset($localdbf_scores[$login]['Rank'])) $localdbf_players[$login]['join_rank'] = $localdbf_scores[$login]['Rank'];
     else $localdbf_players[$login]['join_rank'] = 0;
	 $dbnick = localdbf_sqlesc($newnick);
	 
	if($localdbf_players[$login]['NickName'] != $newnick)
	 {
	 $localdbf_pldb->executeQuery("UPDATE local_players 
							 SET NickName = '$dbnick'
							 WHERE Login = '$login'");
	 }
	$localdbf_players[$login]['NickName'] = $newnick; 
	$localdbf_players[$login]['OldShowRecs'] = 0;
}

function localdbf_player_local_disconnect($login)
{	global $_players, $localdbf_pldb, $localdbf_players;

	$date = date("d.m.Y-H:i:s");
	$time_played = time()-$localdbf_players[$login]['join'];

	$already_played = $localdbf_players[$login]['TimePlayed'];
	$time_played = $already_played + $time_played;
	$localdbf_players[$login]['TimePlayed'] = $time_played;
	$localdbf_players[$login]['LastSeen'] = $date;
	$showrecs = $localdbf_players[$login]['ShowRecs'];
	$showinfo = $localdbf_players[$login]['ShowInfo'];
	$oldshowrecs = $localdbf_players[$login]['OldShowRecs'];
	$language = $localdbf_players[$login]['Nation'];
	
	if($localdbf_players[$login]['OldShowRecs'] != 0 && $localdbf_players[$login]['ShowRecs'] == 4){
	$localdbf_pldb->executeQuery("UPDATE local_players
							SET Nation='$language', TimePlayed='$time_played', LastSeen='$date', ShowRecs='$oldshowrecs', ShowInfo='$showinfo'
							WHERE Login = '$login'");
							 $localdbf_players[$login]['ShowRecs'] = $localdbf_players[$login]['OldShowRecs'];}
	else
	{$localdbf_pldb->executeQuery("UPDATE local_players
							SET Nation='$language', TimePlayed='$time_played', LastSeen='$date', ShowRecs='$showrecs', ShowInfo='$showinfo'
							WHERE Login = '$login'");
	}
	
	
}


// Player Finish updateing records for current track
function localdbf_update_local_records($login, $tracktime)
{	global $localdbf_maxtop, $_PlayerList, $_players, $localdbf_col1, $localdbf_col2, $localdbf_redb, 
			$_ChallengeInfo, $localdbf_players, $localdbf_allrecs;

	// in rounds mode time is 0 when not finished so dont update
	if($tracktime == 0) return;
	
	$recordfile = 'rec_'.$_ChallengeInfo['UId'];
    $uid = $_ChallengeInfo['UId'];

	
	$result=$localdbf_redb->executeQuery("SELECT *
									FROM $recordfile
									WHERE TrackUId = '$uid'
									AND PlayerLogin = '$login'");
	$data = localdbf_GetArray($result);	
	// no record so put it in records
	if(!isset($data[0]))
		{	$date = date("d.m.Y-H:i:s");
			$localdbf_redb->executeQuery("INSERT INTO $recordfile
									VALUES
								   ('$uid','$login','$tracktime','$date','1','0')");		
			//show his trackrank if needed
			
			 $result2=$localdbf_redb->executeQuery("SELECT *
			 						 FROM $recordfile
									 WHERE PlayerTime > '0'	
									 ORDER BY PlayerTime ASC");
			 $data2=localdbf_GetArray($result2);
			 $newrank = 0;
			 foreach($data2 as $rank)
			 {
				$newrank++;
				if($rank['PlayerLogin']== $login) 	break;	
			 }
			
			$nickname = stripLinks(stripEnlarge($localdbf_players[$login]['NickName']));
			$msgforyou = localeText($login,'localdbf.record.top_prefix').
				   		 localeText($login,'localdbf.record.top.foryou',$newrank,MwTimeToString($tracktime));
				   		 
			$displaytracktime = MwTimeToString($tracktime);
			$msgforall = array(1 => 'localdbf.record.top_prefix', 2 => 'localdbf.record.top.forall' , 3 => $nickname,
								4 => $newrank, 5 => $displaytracktime);
			
			addCall(null,"ChatSendServerMessageToLogin", $msgforyou, $login);		
			localdbf_sendmsg_toall($login,$msgforall);
			
			if($newrank <= 10) 
			{localdbfBuildMainXmlToAll();
			 localdbfUpdateMainXmlToAll();			
			}
			else{
				localdbfBuildMainXml($login);
				localdbfUpdateMainXml($login,'refresh');
			}
		
			return;
		}
// player has a record update it if current time better

	$date = date("d.m.Y-H:i:s");
	$tmp_playerfinish = $data[0]['PlayerFinish'];
	$playerfinish = $tmp_playerfinish + 1;
	if($data[0]['PlayerTime'] >= $tracktime  || $data[0]['PlayerTime'] == 0)
	{
	$localdbf_redb->executeQuery("UPDATE $recordfile
							SET PlayerTime='$tracktime', PlayerDate='$date', PlayerFinish='$playerfinish'
							WHERE PlayerLogin='$login'");
	$newrecord = 1;
	}
	else
	{
	$localdbf_redb->executeQuery("UPDATE $recordfile
							SET PlayerFinish='$playerfinish'
							WHERE PlayerLogin='$login'");
	$newrecord = 0;
	}
	
	if($newrecord == 0) return;
	
			//show to player if needed
		
				$result=$localdbf_redb->executeQuery("SELECT *
			 						 			FROM $recordfile
			 						 			WHERE PlayerTime > '0'
									 			ORDER BY PlayerTime ASC");
			 	$data=localdbf_GetArray($result);
	
			$newrank = 0;
			foreach($data as $rank)
			{
				$newrank++;
				if($rank['PlayerLogin']== $login)
				break;	
			}
		
			$nickname = stripLinks(stripEnlarge($localdbf_players[$login]['NickName']));
			$msgforyou = localeText($login,'localdbf.record.top_prefix').
				   		 localeText($login,'localdbf.record.top.foryou',$newrank,MwTimeToString($tracktime));
			$displaytracktime = MwTimeToString($tracktime);
			$msgforall = array(1 => 'localdbf.record.top_prefix', 2 => 'localdbf.record.top.forall' , 3 => $nickname,
								4 => $newrank, 5 => $displaytracktime);
			addCall(null,"ChatSendServerMessageToLogin", $msgforyou, $login);		
			localdbf_sendmsg_toall($login,$msgforall);
			
		if($newrank <= 10)
		{localdbfBuildMainXmlToAll();
			 localdbfUpdateMainXmlToAll();
			   localdbf_SortRecs();			
			}
			else{
				localdbfBuildMainXml($login);
				localdbfUpdateMainXml($login,'refresh');
				localdbf_SortRecs();
			}
		
} 

// Race Begin
function localdbf_manage_local_records($track)
{	global $localdbf_maxtop, $_players,
			$_GameInfos, $localdbf_col1, $localdbf_col2, $_playerlistTime, $localdbf_redb, $localdbf_chdb, $_ChallengeInfo, $localdbf_players;

 	//default values for new track
 	$recordfile = 'rec_'.$_ChallengeInfo['UId'];
 	$name = localdbf_sqlesc($_ChallengeInfo['Name']);
 	$uid = $_ChallengeInfo['UId'];
 	$author = $_ChallengeInfo['AuthorTime'];
 	$copp = $_ChallengeInfo['CopperPrice'];
 	$count = 0;
 	$env = $_ChallengeInfo['Environnement'];
	$file = 'records/'.$recordfile.'.txt';
// check if track exists in database
	if(!file_exists(DB_DIR . 'challenges/'. $uid . '.txt'))
	{	$localdbf_chdb->executeQuery("CREATE TABLE $uid (
  			UId str DEFAULT '',
  			Name str DEFAULT '',
  			AuthorTime int DEFAULT '0',
  			CopperPrice int DEFAULT '0',
  			TrackCount int DEFAULT '0',
			Env str DEFAULT '',
			Speci int DEFAULT '0')");
		
		$localdbf_chdb->executeQuery("INSERT INTO $uid
				VALUES
				('$uid','$name','$author','$copp','$count','$env','0')");	
		
		if(!file_exists(DB_DIR . $file))
		{
		$localdbf_redb->executeQuery("CREATE TABLE $recordfile (
								TrackUId str DEFAULT ' ',
								PlayerLogin str DEFAULT ' ',
								PlayerTime int DEFAULT '0',
								PlayerDate str DEFAULT ' ',
								PlayerFinish int DEFAULT '0',
								PlayerVote int DEFAULT '0'");
		}
	//load the challenge after creation
	}
	$result=$localdbf_chdb->executeQuery("SELECT *
									FROM $uid");
	$data=localdbf_GetArray($result);
// is in database increase trackcounter    

if(isset($_players))
{	
	$trackcounter = $data[0]['TrackCount'];
	$trackcounter++;
	$localdbf_chdb->executeQuery("UPDATE $uid
							SET TrackCount='$trackcounter'");
}	
	
}


function localdbf_wins_counter()
{		global $localdbf_pldb, $_Ranking, $localdbf_players, $localdbf_scdb, $localdbf_scores, $localdbf_players_to_update;

	if(!isset($_Ranking)) return;
	$players_ingame = count($_Ranking);
	if($players_ingame <= 1) return;
	if($_Ranking[0]['BestTime'] == -1) return;
	
	$login = $_Ranking[0]['Login'];
	$data = $localdbf_scores[$login];
	
	if(!isset($data['Wins'])) $data['Wins'] = 0;
	
	$wins = $data['Wins'] + 1;
	$score = $data['Score'] + 0;
	
	/*
	$localdbf_scdb->executeQuery("UPDATE local_scores
							SET Wins = '$wins', Score = '$score'
							WHERE 'Login' = '$login'");
	*/
	
	$localdbf_scores[$login]['Wins'] = $wins;
	$localdbf_scores[$login]['Score'] = $score;
	
	if(!in_array($login,$localdbf_players_to_update))
	array_unshift($localdbf_players_to_update, $login);
	
	$message = localeText($login,'localdbf.winner',$wins);
	addCall(null,"ChatSendServerMessageToLogin", $message, $_Ranking[0]['Login']);
		
}

function localdbf_SortRecs(){
	global $_ChallengeInfo, $localdbf_redb, $localdbf_recs, $localdbf_allrecs, $localdbf_score;
	
	$uid=$_ChallengeInfo['UId'];
	$recordfile='rec_'.$uid;
	if(file_exists(DB_DIR. 'records/'.$recordfile.'.txt')){
		$result=$localdbf_redb->executeQuery("SELECT *
								FROM $recordfile
								WHERE PlayerTime > '0'
								ORDER BY PlayerTime ASC, PlayerDate ASC");
				
		$data = localdbf_GetArray($result);
		// load records for display
				$position = 0;
				foreach($data as $record){
				$localdbf_recs[$position] = $record;
				$playerslogin = $record['PlayerLogin'];
				$localdbf_allrecs[$playerslogin]['Login'] = $playerslogin;
				$localdbf_allrecs[$playerslogin]['PlayerFinish'] = $record['PlayerFinish'];
				$localdbf_allrecs[$playerslogin]['PlayerTime'] = $record['PlayerTime'];
				$localdbf_allrecs[$playerslogin]['Pos'] = $position +1;
				$position++;
				}
		return($data);
	}
	else{
	$localdbf_recs = array();
	$localdbf_allrecs = array();
	return(array());}
}

function localdbf_reset_ranking_track()
{ 	global $localdbf_redb, $_ChallengeInfo, $localdbf_maxtop, $localdbf_oldranking
			,$localdbf_update_ranking, $localdbf_update_ranking_logins, $localdbf_recs, $localdbf_allrecs;

print_r('Loading current scores for next track...'."\n");


$localdbf_update_ranking = array();
$data = localdbf_SortRecs();

		if(!isset($data[0]))
		{
			$localdbf_oldranking = 0;
			return;
		}

		$rankings = count($data);
		if($rankings > $localdbf_maxtop) $rankings = $localdbf_maxtop;
		
		for($i = $rankings; $i > 0; $i--)
		{	
		 	$login = $data[$i-1]['PlayerLogin'];
		 	$points = $rankings-$i+1;
		
			 $localdbf_update_ranking[$login] = $points;
			 array_push($localdbf_update_ranking_logins, $login); 
		}		
		$localdbf_oldranking = 1;
		print_r('Done !!'."\n");
		//print_r($lb_update_ranking);
}

function localdbf_update_ranking()
{	global $localdbf_redb, $localdbf_scdb, $_ChallengeInfo, $localdbf_maxtop, $localdbf_oldranking, $localdbf_update_ranking, $localdbf_update_ranking_logins,
			$localdbf_scores, $localdbf_players_to_update, $localdbf_allranks;


	print_r('-->Local: Getting current endpoints...');
	$uid=$_ChallengeInfo['UId'];
	$recordfile='rec_'.$uid;
		//get current rankings for track
		$data = localdbf_SortRecs();
		if(!isset($data[0])) return; //nutting to update
		
		//$localdbf_players_to_update=array();
		$rankings = count($data);
		if($rankings > $localdbf_maxtop) $rankings = $localdbf_maxtop;
		// calculate current score for track
		for($i = $rankings; $i > 0; $i--)
		{	$found = 0;
		 	$points = $rankings-$i+1;
		 	$login = $data[$i-1]['PlayerLogin'];
		 	$score = $localdbf_scores[$login]['Score'];

			if(in_array($login, $localdbf_update_ranking_logins))
			{$found=1;
			 $newscore = $score + $points - $localdbf_update_ranking[$login];
				if($newscore != $score)
					{
					$localdbf_scores[$login]['Score'] = $newscore;
					array_push($localdbf_players_to_update, $login);
					}	
			}
			if($found == 0)
			{
			//print_r('NOT FOUND???');
			$localdbf_scores[$login]['Score'] = $score + $points;
			array_push($localdbf_players_to_update, $login);	
			}
				
		}
		array_push($localdbf_players_to_update,'done_update_scores');
		//sort the ranking for faster display
/*
 		$tmp_ranking = $localdbf_scores;
 		$sort_ranking = array();
 	 		foreach($tmp_ranking AS $uniqid => $row){
         		foreach($row AS $key=>$value){
             		$sort_ranking[$key][$uniqid] = $value;
         		}
     		}
 	array_multisort($sort_ranking['Score'], SORT_DESC, $tmp_ranking);

 
    $ranking = array();
    foreach($tmp_ranking as $player)
    {
		if($player['Score'] > 0) array_push($ranking, $player);
	}
		$new_rank = 0;
		foreach($ranking as $data){
			$localdbf_allranks[$new_rank]['Login'] = $data['Login'];
			$localdbf_allranks[$new_rank]['Score'] = $data['Score'];
			$localdbf_allranks[$new_rank]['Wins'] = $data['Wins'];
			$new_rank++;
			$localdbf_scores[$data['Login']]['Rank'] = $new_rank;
		}
*/
		print_r('Done'."\n");
}

function localdbfEverysecond($event,$seconds){
	global $localdbf_players_to_update, $localdbf_scdb, $localdbf_scores;
	
	//updateing scorefile
	
	if(isset($localdbf_players_to_update[0]))
	{	
	 
	 if($localdbf_players_to_update[0] != 'done_update_scores'){
	 	//if($localdbf_players_to_update[0] != 0)
		$login = $localdbf_players_to_update[0];
		$score = $localdbf_scores[$login]['Score'];
		$wins = $localdbf_scores[$login]['Wins'];
		$localdbf_scdb->executeQuery("UPDATE local_scores
										SET Score = '$score', Wins = '$wins'
										WHERE Login = '$login'");
	
	//print_r("\n".'------>updated score file'."\n");
	//print_r($localdbf_players_to_update);
										
	$done = array_shift($localdbf_players_to_update);}
	 else{
		$done = array_shift($localdbf_players_to_update);
		localdbfSortLadder();
		//print_r("\n".'-->Local : Scorefile has been updated !!'."\n");
		//print_r("\n".'-->Local : Server Ladder is sorted !!'."\n");
		//print_r($localdbf_players_to_update);
		localdbfBuildMainXmlToAll();
		localdbfUpdateMainXmlToAll();
		}
	}

	//for debug
	//print_r('-->Local : Updated score for - '.$login.' - new score - '.$score."\n");
	//print_r($localdbf_players_to_update);
}



function localdbfBeginRound($event)
{	global $_players, $localdbf_players, $_GameInfos;
	//localdbfBuildMainXml($login);
	 //localdbfSortLadder();
	//localdbfUpdateMainXmlToAll();
	
	foreach($_players as $player){
	 	 if($_GameInfos['GameMode'] == 2){
		 localdbfUpdateMainXml($player['Login'],'hide');
		 }
		 else{
		 localdbfBuildMainXml($player['Login']);
		 if($localdbf_players[$player['Login']]['ShowRecs'] > 0)
		 localdbfUpdateMainXml($player['Login'],'show');	
		 }
	}
	
}

function localdbfEndRace($event,$Ranking,$ChallengeInfo,$GameInfos)
{	global $localdbf_players, $_players;

	localdbf_update_ranking();
	// showing to 10 locals to all when display is on
	foreach($_players as $player){
	$login = $player['Login'];
		if($localdbf_players[$login]['ShowRecs'] != 0){
		$localdbf_players[$login]['OldShowRecs'] = $localdbf_players[$login]['ShowRecs'];
		$localdbf_players[$login]['ShowRecs'] = 4;
		localdbfBuildMainXml($login);
		localdbfUpdateMainXml($login,'show');
		}
		else{
		 localdbfUpdateMainXml($login,'refresh');
		}
	}
	localdbf_wins_counter();
}

function localdbfAnnouncePlayer($login,$action){
	global $_players, $localdbf_players, $localdbf_scores;
	
	$red = '$f00';
	$green = '$9f6';
	
	$nickname = stripLinks($_players[$login]['NickName']);
	$nickname = stripEnlarge($nickname);
	$nickname .= '$z';
	
	
	
	if(!isset($localdbf_scores[$login]['Rank']))
	$norank = true;
	else{
	$norank = false;
	$rank = $localdbf_scores[$login]['Rank'];
	$maxrank = $localdbf_scores[$login]['MaxRank'];
	$score = $localdbf_scores[$login]['Score'];
	$wins = $localdbf_scores[$login]['Wins'];
		if($action == 'leave' || $action == 'stats'){
			$score_change = $score - $localdbf_players[$login]['join_score'];
				if($score_change >= 0) $score_change_color = $green;
				else $score_change_color = $red;
			$rank_change = $rank - $localdbf_players[$login]['join_rank'];
			if($rank_change == $rank) $rank_change = $rank-$maxrank;
				if($rank_change <= 0) $rank_change_color = $green;
				else $rank_change_color = $red;
			$wins_change = $wins - $localdbf_players[$login]['join_wins'];
				if($wins_change > 0) $wins_change_color = $green;
				else $wins_change_color = $red;
		}	
	}
	if($localdbf_players[$login]['ShowInfo'] == 21 || $localdbf_players[$login]['ShowInfo'] == 22)
				$showjoinmsg = true;
			else
				$showjoinmsg = false;
				
			if($norank && $showjoinmsg && $action == 'stats'){
			$msg_txt = localeText($login,'localdbf.joinmsg_norank.stats');
		 	addCall(null,"ChatSendServerMessageToLogin", $msg_txt, $login);
			return;
			}
			if(!$norank && $showjoinmsg && $action == 'stats'){
			$msg_txt = localeText($login,'localdbf.joinmsg_ranked.stats', 
			 					  $rank, $rank_change_color, $rank_change, $score, $score_change_color, 
								  $score_change, $wins, $wins_change_color, $wins_change);
		 	addCall(null,"ChatSendServerMessageToLogin", $msg_txt, $login);		
			return;
			}
	
	
	foreach($_players as $player){
		$playerlogin = $player['Login'];
			// Showinfo -> first value joinmsg (1=off, 2=on) -> second value showallchatrecs (1=off, 2=on)
			if($localdbf_players[$playerlogin]['ShowInfo'] == 21 || $localdbf_players[$playerlogin]['ShowInfo'] == 22)
				$showjoinmsg = true;
			else
				$showjoinmsg = false;
				
			if($norank && $showjoinmsg && $action == 'join'){
		 	$msg_txt = localeText($playerlogin,'localdbf.joinmsg_norank', $nickname);
		 	addCall(null,"ChatSendServerMessageToLogin", $msg_txt, $playerlogin);
		 	}
			elseif(!$norank && $showjoinmsg && $action == 'join'){
			$msg_txt = localeText($playerlogin,'localdbf.joinmsg_ranked', $nickname, $rank, $maxrank, $score, $wins);
			addCall(null,"ChatSendServerMessageToLogin", $msg_txt, $playerlogin);
			}
			elseif($norank && $showjoinmsg && $action == 'leave' && $playerlogin != $login){
			$msg_txt = localeText($playerlogin,'localdbf.joinmsg_norank.leave', $nickname);
		 	addCall(null,"ChatSendServerMessageToLogin", $msg_txt, $playerlogin);	
			}
			elseif(!$norank && $showjoinmsg && $action == 'leave' && $playerlogin != $login){
			$msg_txt = localeText($playerlogin,'localdbf.joinmsg_ranked.leave', 
			 					  $nickname, $rank, $rank_change_color, $rank_change, $score, $score_change_color, 
								  $score_change, $wins, $wins_change_color, $wins_change);
		 	addCall(null,"ChatSendServerMessageToLogin", $msg_txt, $playerlogin);		
			}
	}

}

function localdbfPlayerConnect($event,$login)
{	global $localdbf_joinmsg, $_GameInfos, $localdbf_is_glider;

	localdbf_player_local_connect($login);
	localdbfBuildMainXml($login);
	localdbfUpdateMainXml($login,'remove');
	if($_GameInfos['GameMode'] != 2){
	localdbfUpdateMainXml($login,'show');}
	localdbfAnnouncePlayer($login,'join');
	if($localdbf_is_glider)
	localdbfUpdateMenu();
}

function localdbfPlayerDisconnect($event,$login)
{	global $_PlayerList, $localdbf_is_glider;
	
	localdbf_player_local_disconnect($login);
	localdbfAnnouncePlayer($login,'leave');
	
	if($localdbf_is_glider)
	localdbfUpdateMenu();
}

function localdbfPlayerFinish($event,$login,$time)
{	global $_GameInfos, $_players;

	localdbf_update_local_records($login, $time);
	
	if($_GameInfos['GameMode'] != 1 && $time != 0){
		foreach($_players as $player) localdbfUpdateMainXml($player['Login'],'hide');
	}
}
function localdbfPlayerShowML($event,$login,$ShowML){
	global $_mldebug;
	if($_mldebug>0) console("ml_howto.Event[$event]('$login',$ShowML)");

	if($ShowML>0){
	 	localdbfBuildMainXml($login);
		localdbfUpdateMainXml($login,'show');
		localdbfPlayerMenuBuild($event,$login);
	}	
}
function localdbfBeginChallenge($event,$ChallengeInfo,$GameInfos)
{	global $_players, $localdbf_players, $_GameInfos, $localdbf_allrecs, $localdbf_recs;
	
	$localdbf_allrecs = array();
	$localdbf_recs = array();
	localdbf_manage_local_records($ChallengeInfo);
	localdbf_reset_ranking_track();
	
	localdbfBuildMainXmlToAll();
	
	if($_GameInfos['GameMode'] == 2)
		foreach($_players as $player) localdbfUpdateMainXml($player['Login'],'hide');
	else
	localdbfUpdateMainXmlToAll();
	
				foreach($_players as $player){
		  	$login = $player['Login'];
		  	if($localdbf_players[$login]['OldShowRecs'] > 0 && $localdbf_players[$login]['ShowRecs'] == 4){
			$localdbf_players[$login]['ShowRecs'] = $localdbf_players[$login]['OldShowRecs'];
			$localdbf_players[$login]['OldShowRecs'] = 0;
			localdbfBuildMainXml($login);
			localdbfUpdateMainXml($login,'refresh');
			}
			else
			{
			localdbfBuildMainXml($login);
			localdbfUpdateMainXml($login,'refresh');	
			}
		}
}

function localdbfIgnoreListChange($event,$ignorelist){
	global $localdbf_is_glider;
	
	if($localdbf_is_glider)
	localdbfUpdateMenu();
}
function localdbfBanListChange($event,$banlist){
	global $localdbf_is_glider;
	
	if($localdbf_is_glider)
	localdbfUpdateMenu();
}
function localdbfBlackListChange($event,$blacklist){
	global $localdbf_is_glider;
	
	if($localdbf_is_glider)
	localdbfUpdateMenu();
}
function localdbfAdminChange($event,$login,$isadmin){
	global $localdbf_is_glider;
	
	if($localdbf_is_glider)
	localdbfUpdateMenu();
}
function localdbfUpdateMenu(){
	global $_players;
	foreach($_players as $k=>$v)
			localdbfPlayerMenuBuild('refresh',$k);
}

function localdbfStatusChanged($event,$Status,$StatusCode){
	global $_old_Status, $_GameInfos, $_players, $localdbf_players;
	
	//console("localdbf.Event[$event]($StatusCode) [old=".$_old_Status['Code']."]");
	//Status[Code]=1, Status[Name]=Waiting
	//Status[Code]=2, Status[Name]=Launching
	//Status[Code]=3, Status[Name]=Running - Synchronization
	//Status[Code]=4, Status[Name]=Running - Play
	//Status[Code]=5, Status[Name]=Running - Finish
}
	

function localdbfPlayerChat($event, $login){
	
	//localdbfUpdateMainXml($login,'hide');
}

function localdbfStartRace($event, $GameInfos, $ChallengeInfo)
{		global $_players, $localdbf_players;
	//print_r($GameInfos);
	//localdbf_manage_local_records($ChallengeInfo);
	//localdbf_reset_ranking_track();
	//localdbfBuildMainXmlToAll();
	//localdbfUpdateMainXmlToAll();

}

function localdbfSortLadder(){
 	global $localdbf_scdb, $localdbf_scores, $localdbf_players, $localdbf_allranks;
 	
 	$result = $localdbf_scdb->executeQuery("SELECT * FROM local_scores
	 										WHERE
											Score > '0'
											ORDER BY Score DESC");
	$data = localdbf_GetArray($result);
	$counter = count($data);
	$localdbf_allranks = $data;

	for($i=0; $i<$counter;$i++){
			$login = $data[$i]['Login'];
			$localdbf_scores[$login]['Score'] = $data[$i]['Score'];
			$localdbf_scores[$login]['Wins'] = $data[$i]['Wins'];
			$localdbf_scores[$login]['Rank'] = $i+1;
			$localdbf_scores[$login]['MaxRank'] = $counter;
	} 
}

//************ building the main window *****************//
function localdbfBuildMainXml($login){
	global $_mldebug, $_ml_act, $localdbf_main_xml, $_players, $_ChallengeInfo, $localdbf_redb, 
			$localdbf_players, $localdbf_scores, $localdbf_config, $localdbf_allranks;
	
	$col = array(1 => $localdbf_config['col1'], 2 => $localdbf_config['col2'], 3 => $localdbf_config['col3'],
				 4 => $localdbf_config['col4'], 5 => $localdbf_config['col5'], 6 => $localdbf_config['col6']);
	
	$mainlabel = '$o'.$col[1];
	$mainlabel .= localeText($login,'localdbf.mainlabel');
	$label_rank = localeText($login,'localdbf.label_rank');
	$label_norank = localeText($login,'localdbf.label_norank');
	$label_score = localeText($login,'localdbf.label_score');
	$label_norecord = localeText($login,'localdbf.label_norecord');
	$label_norecordforyou = localeText($login,'localdbf.label_norecordforyou');
	$label_pb = localeText($login,'localdbf.label_pb');
	$label_top = localeText($login,'localdbf.label_top');
	
	$player_found = false;
	$norecord = true;
	$localdbf_main_xml[$login]['ShowRecs'] = $localdbf_players[$login]['ShowRecs'];
	$localdbf_main_mxl[$login]['ShowInfo'] = $localdbf_players[$login]['ShowInfo'];
	$up=$_ml_act['localdbf_main.up'];
	$down=$_ml_act['localdbf_main.down'];
	$tops=$_ml_act['localdbf_top.open'];
	$recs=$_ml_act['localdbf_recs.open'];
	$admin=$_ml_act['localdbf_admin.open'];
		
	$uid=$_ChallengeInfo['UId'];
	$recordfile='rec_'.$uid;
	if(!file_exists(DB_DIR.'records/'.$recordfile.'.txt')) return;
			
	$result=$localdbf_redb->executeQuery("SELECT *
							 		FROM $recordfile
									WHERE PlayerTime > '0'
									ORDER BY PlayerTime ASC, PlayerDate ASC");
									
	$data=localdbf_GetArray($result);
	if(!isset($data[0])){
		$top = $col[3].localeText($login,'localdbf.label_norecord');
	}
	else{
		//find players pb 
		$norecord = false;
		$player_position = 0;
		$counter = count($data);
		for($i=0; $i < $counter; $i++){
			if($data[$i]['PlayerLogin'] == $login){
			$player_found = true;
			$player_time = $data[$i]['PlayerTime'];
			$player_finish = $data[$i]['PlayerFinish'];
			$player_date = $data[$i]['PlayerDate'];
			$player_position = $i+1;
			break;	
			}
		}
	}
	//paint players server rank
	
	if(isset($localdbf_scores[$login]['Rank'])){
	$serverrank = 	'<label sizen="14.5 2" posn="1.2 -5.9 0.02" halign="left" text="'.$col[3].$label_rank.$col[6].$localdbf_scores[$login]['Rank'].' / '.
					$localdbf_scores[$login]['MaxRank'].'    '.$col[3].$label_score.'"/>'
						.'<label sizen="4.5  2" posn="16.5 -5.9 0.02" halign="left" text="'.$col[6].$localdbf_scores[$login]['Score'].'"/>';
	}
	else{					
	$serverrank = 	'<label sizen="14.5 2" posn="1.2 -5.9 0.02" halign="left" text="'.$col[3].$label_rank.$col[2].$label_norank.$col[3].$label_score.'"/>'
						.'<label sizen="4.5  2" posn="16.5 -5.9 0.02" halign="left" text="'.$col[3].'0"/>';
	}
	//display top 1 record
	if($localdbf_main_xml[$login]['ShowRecs'] > 0)
	{


				// draw a small window
				$localdbf_main_xml[$login]['msg'] = '<frame posn="%0.2f %0.2f 0"><format textsize="1"/>'
				.'<quad sizen="23 %0.2f" posn="0 0 0" style="Bgs1" substyle="NavButton"/>'
				.sprintf('<label sizen="10 1" posn="11 -0.3 0.02" halign="left" text="'.$mainlabel.'"/>');
				$line = -0.2;
				if($player_found){
				 	
				 	//$player_nick = stripEnlarge($localdbf_players[$login]['NickName']);
				 	$player_nick = $col[3].$label_pb.$col[1].$player_position.' '.$col[6].'- '.$player_date.' - '.$player_finish;
				 	$player_time = $col[3].MwTimeToString($player_time);
					$pb = '<label sizen="14.5 2" posn="1.2 -3.9 0.02" halign="left" text="'.$player_nick.'"/>'
						.'<label sizen="4.5  2" posn="16.5 -3.9 0.02" halign="left" text="'.$player_time.'"/>';
				}
				else{
				 	$player_nick = $col[2].$label_norecordforyou;
					$pb = '<label sizen="23 2" posn="1.5 -3.9 0.02" halign="left" text="'.$player_nick.'"/>';
				}
				if($norecord){
					$top1 = $top;
					$top2 = '';
					$localdbf_main_xml[$login]['msg'] .= sprintf('<label sizen="14.5 2" posn="1.2 -2 0.02" halign="left" text="'.$top1.'"/>'
													.'<label sizen="4.5  2" posn="16.5 -2 0.02" halign="left" text="'.$top2.'"/>');
				}
				else{
						
				$nickname=$localdbf_players[$data[0]['PlayerLogin']]['NickName'];
				$nickname= stripEnlarge($nickname);	
				$nickname= localdbf_mlesc($nickname);
				$top1 = $col[5].$label_top.$col[4].'1 '.$col[5].'- ';
				$top15 = $nickname;
				$top2 = $col[4].MwTimeToString($data[0]['PlayerTime']);
				$localdbf_main_xml[$login]['msg'] .= sprintf(
				'<label sizen="3 2" posn="1.2 -2 0.02" halign="left" text="'.$top1.'"/>'
				.'<label sizen="12 2" posn="4.2 -2 0.02" halign="left" text="'.$top15.'"/>'
				.'<label sizen="4.5  2" posn="16.5 -2 0.02" halign="left" text="'.$top2.'"/>');
					//display top 3 records
						if($localdbf_main_xml[$login]['ShowRecs'] == 2){
							$counter = count($data);
							if($counter > 3) $counter = 3;
							//draw a bigger window
							$localdbf_main_xml[$login]['msg'] = '<frame posn="%0.2f %0.2f 0"><format textsize="1"/>'
							.'<quad sizen="23 14" posn="0 6 0" style="Bgs1" substyle="NavButton"/>'
							.sprintf('<label sizen="10 1" posn="11 5.7 0.02" halign="left" text="'.$mainlabel.'"/>');
							$line = 5.9;
							$nextline = $line - 1.9;
							for($i=0; $i < $counter ; $i++)
							{		
						 		$nickname=$localdbf_players[$data[$i]['PlayerLogin']]['NickName'];
								$nickname= stripEnlarge($nickname);	
								$nickname=localdbf_mlesc($nickname);
								$top0 = $i+1;
								$top1 = $col[5].$label_top.$col[4].$top0.$col[5].' - ';
								$top15 = $nickname;
								$top2 = $col[4].MwTimeToString($data[$i]['PlayerTime']);
								$localdbf_main_xml[$login]['msg'] .= 
								'<label sizen="3 2" posn="1.2 '.$nextline.' 0.02" halign="left" text="'.$top1.'"/>'
								.'<label sizen="12 2" posn="4.2 '.$nextline.' 0.02" halign="left" text="'.$top15.'"/>'
								.'<label sizen="4.5  2" posn="16.5 '.$nextline.' 0.02" halign="left" text="'.$top2.'"/>';
								$nextline = $nextline - 1.9;
							}
						}
						elseif($localdbf_main_xml[$login]['ShowRecs'] == 3){
						 $counter = count($data);
							if($counter > 5) $counter = 5;
							//draw a bigger window
							$localdbf_main_xml[$login]['msg'] = '<frame posn="%0.2f %0.2f 0"><format textsize="1"/>'
							.'<quad sizen="23 18" posn="0 10 0" style="Bgs1" substyle="NavButton"/>'
							.sprintf('<label sizen="10 1" posn="11 9.7 0.02" halign="left" text="'.$mainlabel.'"/>');
							$line = 9.9;
							$nextline = $line - 1.9;
							for($i=0; $i < $counter ; $i++)
								{		
							 		$nickname=$localdbf_players[$data[$i]['PlayerLogin']]['NickName'];
									$nickname= stripEnlarge($nickname);	
									$nickname= localdbf_mlesc($nickname);
									$top0 = $i+1;
									$top1 = $col[5].$label_top.$col[4].$top0.$col[5].' - ';
									$top15 = $nickname;
									$top2 = $col[4].MwTimeToString($data[$i]['PlayerTime']);
									$localdbf_main_xml[$login]['msg'] .= 
									'<label sizen="3 2" posn="1.2 '.$nextline.' 0.02" halign="left" text="'.$top1.'"/>'
									.'<label sizen="12 2" posn="4.2 '.$nextline.' 0.02" halign="left" text="'.$top15.'"/>'
									.'<label sizen="4.5  2" posn="16.5 '.$nextline.' 0.02" halign="left" text="'.$top2.'"/>';
									$nextline = $nextline - 1.9;
								}
						}
						elseif($localdbf_main_xml[$login]['ShowRecs'] == 4){
							$counter = count($data);
							if($counter > 10) $counter = 10;
							//draw a bigger window 
							$localdbf_main_xml[$login]['msg'] = '<frame posn="%0.2f %0.2f 0"><format textsize="1"/>'
							.'<quad sizen="23 28" posn="0 20 0" style="Bgs1" substyle="NavButton"/>'
							.sprintf('<label sizen="10 1" posn="11 19.7 0.02" halign="left" text="'.$mainlabel.'"/>');
							$line = 19.9;
							$nextline = $line - 1.9;
							for($i=0; $i < $counter ; $i++)
								{		
							 		$nickname=$localdbf_players[$data[$i]['PlayerLogin']]['NickName'];
									$nickname= stripEnlarge($nickname);	
									$nickname= localdbf_mlesc($nickname);
									$top0 = $i+1;
									$top1 = $col[5].$label_top.$col[4].$top0.$col[5].' - ';
									$top15 = $nickname;
									$top2 = $col[4].MwTimeToString($data[$i]['PlayerTime']);
									$localdbf_main_xml[$login]['msg'] .= 
									'<label sizen="3 2" posn="1.2 '.$nextline.' 0.02" halign="left" text="'.$top1.'"/>'
									.'<label sizen="12 2" posn="4.2 '.$nextline.' 0.02" halign="left" text="'.$top15.'"/>'
									.'<label sizen="4.5  2" posn="16.5 '.$nextline.' 0.02" halign="left" text="'.$top2.'"/>';
									$nextline = $nextline - 1.9;
								}
						}
				} //end recordlist drawing
				$line1 = $line-0.2;
			$upbutton = '<quad posn="9 '.$line.' 0.1" sizen="1.8 1.8" style="Icons64x64_1" substyle="YellowHigh" action="'.$up.'"/>';
			$downbutton = '<quad posn="7.7 '.$line.' 0.1" sizen="1.8 1.8" style="Icons64x64_1" substyle="YellowLow" action="'.$down.'"/>';
			$topbutton = '<quad posn="5.8 '.$line1.' 0.1" sizen="1.6 1.6" style="Icons128x32_1" substyle="RT_Cup" action="'.$tops.'"/>';
			$recsbutton = '<quad posn="3.8 '.$line.' 0.1" sizen="1.8 1.8" style="Icons128x32_1" substyle="RT_TimeAttack" action="'.$recs.'"/>';
			$adminbutton = '<quad posn="1.3 '.$line.' 0.1" sizen="2.1 2.1" style="Icons64x64_1" substyle="ButtonLeagues" action="'.$admin.'"/>';
			//close the window with pb
			//if(verifyAdmin($login))	
			$localdbf_main_xml[$login]['msg'] .= $upbutton.$downbutton.$topbutton.$recsbutton.$adminbutton.$pb.$serverrank;
			//else
			//$localdbf_main_xml[$login]['msg'] .= $upbutton.$downbutton.$topbutton.$recsbutton.$pb.$serverrank;
							
			$localdbf_main_xml[$login]['msg'] .= sprintf('</frame>');	
	}

}

function localdbfUpdateMainXml($login,$action='show'){
	global $_mldebug,$_players,$localdbf_main_xml;
	// if the players disabled manialinks then do nothing
	if(!isset($_players[$login]['ML']['ShowML']) || $_players[$login]['ML']['ShowML']<=0)
		return;
	$status = $_players[$login]['Status'];
	if($_mldebug>3) console("localdbfUpdateMainXml('$login',$action) - $status");

	if($action=='remove'){
		// remove manialink
		manialinksRemove($login,'localdbf_main');
		return;

	}elseif($action=='hide'){
		// hide manialink
		manialinksHide($login,'localdbf_main');
		return;

	}elseif($action=='refresh' && !manialinksIsOpened($login,'localdbf_main')){
		// refresh but not opened: do nothing
		return;
	}

	// show/refresh
		if(isset($localdbf_main_xml[$login]['msg'])){
		$xml = sprintf($localdbf_main_xml[$login]['msg'],42.5,-14,8);
		manialinksShow($login,'localdbf_main',$xml);}

}

function localdbfUpdateMainXmlToAll()
{	global $_players;

	foreach($_players as $player)
		localdbfUpdateMainXml($player['Login'],'refresh');	
}

function localdbfBuildMainXmlToAll()
{	global $_players;

	foreach($_players as $player)
		localdbfBuildMainXml($player['Login']);	
}
// server ladder
function localdbfBuildTopXml($login)
{	global $localdbf_top_xml, $localdbf_scores, $localdbf_players, $localdbf_allranks, $_mldebug, $_ml_act, $localdbf_config;

	$col = array(1 => $localdbf_config['col1'], 2 => $localdbf_config['col2'], 3 => $localdbf_config['col3'],
				 4 => $localdbf_config['col4'], 5 => $localdbf_config['col5'], 6 => $localdbf_config['col6']);
	$dsp_list_rank = localeText($login,'localdbf.list_rank');
	$dsp_list_nick = localeText($login,'localdbf.list_nick');
	$dsp_list_wins = localeText($login,'localdbf.list_wins');
	$dsp_list_score = localeText($login,'localdbf.list_score');
	$dsp_list_gap = localeText($login,'localdbf.list_gap');
	$list_label_ladder = localeText($login,'localdbf.mainlabel.ladder');
	
	$nonextrank = true;
	$noprevrank = true;
	// draw the serverranking	
	$openbox=$_ml_act['localdbf_top.open'];
	$line = -3;
	
	$localdbf_top_xml[$login]['msg'] = '<frame posn="%0.2f %0.2f 0"><format textsize="3" />'
		.'<quad sizen="70 %0.2f" posn="-11.5 0 0" style="Bgs1" substyle="BgList"/>'
		.sprintf('<quad sizen="26 3.7" posn="11 1.7 0.02" style="Bgs1InRace" substyle="BgWindow1" action="'.$openbox.'"/>'
				.'<label sizen="22 2" posn="24 1 0.02" halign="center" text="'.$list_label_ladder.'"/>');
	
	$counter = count($localdbf_allranks);
	
	$maxpage = ceil($counter / 20);
	
	$listindex = $localdbf_top_xml[$login]['idx'] + 19;
	$currentpage = ceil($listindex / 20);
	if($currentpage <1) $currentpage = 1;
	
	settype($currentpage,'int');

	if($listindex >= $counter) $listindex = $counter -1 ;
	$line2 = $line - 0.2;
	//firstline
	$localdbf_top_xml[$login]['msg'] .= sprintf(
				'<quad sizen="64 2" posn="-9 '.$line.' 0.02" style="BgsPlayerCard" substyle="BgRacePlayerLine"/>'
				.'<label textsize="2" sizen="8 2" posn="-9 '.$line2.' 0.02" halign="left" text="'.$dsp_list_rank.'"/>'
				.'<label textsize="2" sizen="41 2" posn="-1 '.$line2.' 0.02" halign="left" text="'.$dsp_list_nick.'"/>'
				.'<label textsize="2" sizen="5 2" posn="40 '.$line2.' 0.02" halign="left" text="'.$dsp_list_wins.'"/>'
				.'<label textsize="2" sizen="10 2" posn="45 '.$line2.' 0.02" halign="left" text="'.$dsp_list_score.'"/>');
				
	$line = $line - 2.8;
		
	for($i = $localdbf_top_xml[$login]['idx']; $i <= $listindex; $i++)
	{
	
	$loginforlist = $localdbf_allranks[$i]['Login'];
	$nicknameforlist = stripEnlarge($localdbf_players[$loginforlist]['NickName']);
	$nicknameforlist = localdbf_mlesc($nicknameforlist);
	$nicknameforlist = $nicknameforlist.'$z'.$col[1];
	$rank = $i+1;
	$wins = $localdbf_scores[$loginforlist]['Wins'];
	$score = $localdbf_scores[$loginforlist]['Score'];
	
	//other lines
	$action = $_ml_act['localdbf_top.open'];
	$localdbf_top_xml[$login]['msg'] .= sprintf(
		'<label textsize="2" sizen="8 2" posn="-9 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s."/>'
		.'<label textsize="2" sizen="41 2" posn="-1 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s"/>'
		.'<label textsize="2" sizen="5 2" posn="40 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s"/>'
		.'<label textsize="2" sizen="10 2" posn="45 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s"/>'
		,$rank, $nicknameforlist, $wins, $score);

	$line = $line - 2.5;
	
	}
	$line = $line - 2;
	$line2 = $line - 0.2;
	//middle line
	$localdbf_top_xml[$login]['msg'] .= sprintf(
				'<quad sizen="64 2" posn="-9 '.$line.' 0.02" style="BgsPlayerCard" substyle="BgRacePlayerLine"/>'
				.'<label textsize="2" sizen="8 2" posn="-9 '.$line2.' 0.02" halign="left" text="'.$dsp_list_rank.'"/>'
				.'<label textsize="2" sizen="33 2" posn="-1 '.$line2.' 0.02" halign="left" text="'.$dsp_list_nick.'"/>'
				.'<label textsize="2" sizen="5 2" posn="32 '.$line2.' 0.02" halign="left" text="'.$dsp_list_wins.'"/>'
				.'<label textsize="2" sizen="10 2" posn="37 '.$line2.' 0.02" halign="left" text="'.$dsp_list_score.'"/>'
				.'<label textsize="2" sizen="8 2" posn="47 '.$line2.' 0.02" halign="left" text="'.$dsp_list_gap.'"/>'
				);
				
	$line = $line - 2.8;
	//paint players server rank
	if(isset($localdbf_scores[$login]['Rank'])){
	$player_nick = stripEnlarge($localdbf_players[$login]['NickName']);
	$player_nick = localdbf_mlesc($player_nick);
	$player_nick = $player_nick.'$z';
	$player_score = $localdbf_scores[$login]['Score'];
	$player_wins = $localdbf_scores[$login]['Wins'];
	$player_rank = $localdbf_scores[$login]['Rank'];
	$player_rank_dsp = $player_rank;
	 
	$next_rank = $player_rank - 1;
	if($next_rank >= 0){
	$next_rank_login = $localdbf_allranks[$next_rank]['Login'];
	$next_rank_nick = stripEnlarge($localdbf_players[$next_rank_login]['NickName']);
	$next_rank_nick = localdbf_mlesc($next_rank_nick);
	$next_rank_nick = $next_rank_nick.'$z';
	$next_rank_score = $localdbf_scores[$next_rank_login]['Score'];
	$next_rank_wins = $localdbf_scores[$next_rank_login]['Wins'];
	$next_rank_gap = $next_rank_score-$player_score;
	$next_rank_dsp = $player_rank_dsp + 2;
	$nonextrank = false;
	}

	$prev_rank = $player_rank;
	if($prev_rank < $localdbf_scores[$login]['MaxRank']){
	$prev_rank_login = $localdbf_allranks[$prev_rank]['Login'];
	$prev_rank_nick = stripEnlarge($localdbf_players[$prev_rank_login]['NickName']);
	$prev_rank_nick = localdbf_mlesc($prev_rank_nick);
	$prev_rank_nick = $prev_rank_nick.'$z';
	$prev_rank_score = $localdbf_scores[$prev_rank_login]['Score'];
	$prev_rank_wins = $localdbf_scores[$prev_rank_login]['Wins'];	
	$prev_rank_gap = $prev_rank_score - $player_score;
	$prev_rank_dsp = $player_rank_dsp + 1;
	$noprevrank = false;
	}
	if(!$nonextrank){
				$localdbf_top_xml[$login]['msg'] .= sprintf(
					'<label textsize="2" sizen="8 2" posn="-9 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s."/>'
					.'<label textsize="2" sizen="33 2" posn="-1 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s"/>'
					.'<label textsize="2" sizen="5 2" posn="32 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s"/>'
					.'<label textsize="2" sizen="10 2" posn="37 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s"/>'
					.'<label textsize="2" sizen="8 2" posn="47 '.$line.' 0.02" halign="left" action="'.$action.'" text="'.$col[3].' %s"/>'
					,$next_rank_dsp, $next_rank_nick, $next_rank_wins, $next_rank_score, $next_rank_gap);	 
	$line = $line - 2.5;
					}
	
				$localdbf_top_xml[$login]['msg'] .= sprintf(
					'<label textsize="2" sizen="8 2" posn="-9 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s."/>'
					.'<label textsize="2" sizen="33 2" posn="-1 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s"/>'
					.'<label textsize="2" sizen="5 2" posn="32 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s"/>'
					.'<label textsize="2" sizen="10 2" posn="37 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s"/>'
					,$player_rank_dsp, $player_nick, $player_wins, $player_score);
	$line = $line - 2.5;
	
	if(!$noprevrank){
				$localdbf_top_xml[$login]['msg'] .= sprintf(
					'<label textsize="2" sizen="8 2" posn="-9 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s."/>'
					.'<label textsize="2" sizen="33 2" posn="-1 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s"/>'
					.'<label textsize="2" sizen="5 2" posn="32 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s"/>'
					.'<label textsize="2" sizen="10 2" posn="37 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s"/>'
					.'<label textsize="2" sizen="8 2" posn="47 '.$line.' 0.02" halign="left" action="'.$action.'" text="'.$col[4].' %s"/>'
					,$prev_rank_dsp, $prev_rank_nick, $prev_rank_wins, $prev_rank_score, $prev_rank_gap);
				   }
	}
	
								 
		$localdbf_top_xml[$login]['msg'] .= localdbf_ml_gui('PageNavi',array($currentpage, $maxpage),
										array($_ml_act['localdbf_top.back'], $_ml_act['localdbf_top.next'], $_ml_act['localdbf_top.open']),
										array(40,1,2));
								 							
	$localdbf_top_xml[$login]['msg'] .= sprintf('</frame>');
}

function localdbfUpdateTopXml($login,$action='show'){
	global $_mldebug,$_players,$localdbf_top_xml;
	// if the players disabled manialinks then do nothing
	if(!isset($_players[$login]['ML']['ShowML']) || $_players[$login]['ML']['ShowML']<=0)
		return;
	$status = $_players[$login]['Status'];
	if($_mldebug>3) console("localdbfUpdateTopXml('$login',$action) - $status");

	if($action=='remove'){
		// remove manialink
		manialinksRemove($login,'localdbf_top');
		return;

	}elseif($action=='hide'){
		// hide manialink
		manialinksHide($login,'localdbf_top');
		return;

	}elseif($action=='refresh' && !manialinksIsOpened($login,'localdbf_top')){
		// refresh but not opened: do nothing
		return;
	}

	// show/refresh
	$xml = sprintf($localdbf_top_xml[$login]['msg'],-24,40,72);
		manialinksShow($login,'localdbf_top',$xml);
}
// current track records
function localdbfBuildRecsXml($login)
{	global $localdbf_recs_xml, $localdbf_players, $_mldebug, $_ml_act, $localdbf_config, $localdbf_recs, $localdbf_allrecs;

	$col = array(1 => $localdbf_config['col1'], 2 => $localdbf_config['col2'], 3 => $localdbf_config['col3'],
				 4 => $localdbf_config['col4'], 5 => $localdbf_config['col5'], 6 => $localdbf_config['col6']);
	$list_label_recs = localeText($login,'localdbf.mainlabel.trackrecs');
	$dsp_list_position = localeText($login,'localdbf.list_position');
	$dsp_list_nick = localeText($login,'localdbf.list_nick');
	$dsp_list_finished = localeText($login,'localdbf.list_finished');
	$dsp_list_time = localeText($login,'localdbf.list_time');
	$dsp_list_gap = localeText($login,'localdbf.list_gap');
	
	$nonextrec = true;
	$noprevrec = true;
	$norec = true;
	
	// draw the serverranking	
	$openbox=$_ml_act['localdbf_recs.open'];
	$line = -3;
	
	$localdbf_recs_xml[$login]['msg'] = '<frame posn="%0.2f %0.2f 0"><format textsize="3" />'
		.'<quad sizen="70 %0.2f" posn="-11.5 0 0" style="Bgs1" substyle="BgList"/>'
		.sprintf('<quad sizen="26 3.7" posn="11 1.7 0.02" style="Bgs1InRace" substyle="BgWindow1" action="'.$openbox.'"/>'
				.'<label sizen="22 2" posn="24 1 0.02" halign="center" text="'.$list_label_recs.'" />');
	
	$counter = count($localdbf_recs);
	$maxpage = ceil($counter / 20);
	if(!isset($localdbf_recs_xml[$login]['idx'])) $localdbf_recs_xml[$login]['idx'] = 0;
	$listindex = $localdbf_recs_xml[$login]['idx'] + 19;

	$currentpage = ceil($listindex / 20);
	if($currentpage <1) $currentpage = 1;
	
	settype($currentpage,'int');

	if($listindex >= $counter) $listindex = $counter - 1;
	$line2 = $line - 0.2;
	//firstline
	$localdbf_recs_xml[$login]['msg'] .= sprintf(
				'<quad sizen="64 2" posn="-9 '.$line.' 0.02" style="BgsPlayerCard" substyle="BgRacePlayerLine"/>'
				.'<label textsize="2" sizen="8 2" posn="-9 '.$line2.' 0.02" halign="left" text="'.$dsp_list_position.'"/>'
				.'<label textsize="2" sizen="41 2" posn="-1 '.$line2.' 0.02" halign="left" text="'.$dsp_list_nick.'"/>'
				.'<label textsize="2" sizen="5 2" posn="40 '.$line2.' 0.02" halign="left" text="'.$dsp_list_finished.'"/>'
				.'<label textsize="2" sizen="10 2" posn="45 '.$line2.' 0.02" halign="left" text="'.$dsp_list_time.'"/>');
				
	$line = $line - 2.8;
		
	for($i = $localdbf_recs_xml[$login]['idx']; $i <= $listindex; $i++)
	{
	
	$loginforlist = $localdbf_recs[$i]['PlayerLogin'];
	$nicknameforlist = stripEnlarge($localdbf_players[$loginforlist]['NickName']);
	$nicknameforlist = localdbf_mlesc($nicknameforlist);
	
	$nicknameforlist = $nicknameforlist.'$z'.$col[1];
	$pos = $i+1;
	$time = $localdbf_allrecs[$loginforlist]['PlayerTime'];
	$time_dsp = MwTimeToString($time);
	$finish = $localdbf_allrecs[$loginforlist]['PlayerFinish'];
	
	//other lines
	$action = $_ml_act['localdbf_recs.open'];
	$localdbf_recs_xml[$login]['msg'] .= sprintf(
		'<label textsize="2" sizen="8 2" posn="-9 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s."/>'
		.'<label textsize="2" sizen="41 2" posn="-1 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s"/>'
		.'<label textsize="2" sizen="5 2" posn="40 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s"/>'
		.'<label textsize="2" sizen="10 2" posn="45 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s"/>'
		,$pos, $nicknameforlist, $finish, $time_dsp);

	$line = $line - 2.5;
	
	}
	$line = $line - 2;
	$line2 = $line - 0.2;
	//middle line
	$localdbf_recs_xml[$login]['msg'] .= sprintf(
				'<quad sizen="64 2" posn="-9 '.$line.' 0.02" style="BgsPlayerCard" substyle="BgRacePlayerLine"/>'
				.'<label textsize="2" sizen="8 2" posn="-9 '.$line2.' 0.02" halign="left" text="%s"/>'
				.'<label textsize="2" sizen="33 2" posn="-1 '.$line2.' 0.02" halign="left" text="%s"/>'
				.'<label textsize="2" sizen="5 2" posn="32 '.$line2.' 0.02" halign="left" text="%s"/>'
				.'<label textsize="2" sizen="10 2" posn="37 '.$line2.' 0.02" halign="left" text="%s"/>'
				.'<label textsize="2" sizen="8 2" posn="47 '.$line2.' 0.02" halign="left" text="%s"/>'
				,$dsp_list_position,$dsp_list_nick,$dsp_list_finished,$dsp_list_time,$dsp_list_gap);
				
	$line = $line - 2.8;
	//paint players server rank
	if(isset($localdbf_allrecs[$login])){
	$norec = false;
	$player_nick = stripEnlarge($localdbf_players[$login]['NickName']);
	$player_nick = localdbf_mlesc($player_nick);
	$player_nick = $player_nick.'$z';
	$player_rec = $localdbf_allrecs[$login]['PlayerTime'];
	$player_rec = MwTimeToString($player_rec);
	$player_fin = $localdbf_allrecs[$login]['PlayerFinish'];
	$player_pos = $localdbf_allrecs[$login]['Pos'];
	
	 
	$next_rec_pos = $player_pos - 2;
	if($next_rec_pos >= 0){
	$next_rec_login = $localdbf_recs[$next_rec_pos]['PlayerLogin'];
	$next_rec_nick = stripEnlarge($localdbf_players[$next_rec_login]['NickName']);
	$next_rec_nick = localdbf_mlesc($next_rec_nick);
	$next_rec_nick = $next_rec_nick.'$z';
	$next_rec = $localdbf_allrecs[$next_rec_login]['PlayerTime'];
	$next_rec = MwTimeToString($next_rec);
	$next_rec_fin = $localdbf_allrecs[$next_rec_login]['PlayerFinish'];
	$next_rec_gap = $localdbf_allrecs[$login]['PlayerTime']-$localdbf_allrecs[$next_rec_login]['PlayerTime'];
	$next_rec_gap = MwTimeToString($next_rec_gap);
	$next_rec_gap = '-'.$next_rec_gap;
	$nonextrec = false;
	$next_rec_pos += 1;
	}

	$prev_rec_pos = $player_pos;
	$maxrecs = count($localdbf_recs);
	$maxrecs = $maxrecs + 1;
	if($prev_rec_pos < $maxrecs){
	$prev_rec_login = $localdbf_recs[$prev_rec_pos]['PlayerLogin'];
	$prev_rec_nick = stripEnlarge($localdbf_players[$prev_rec_login]['NickName']);
	$prev_rec_nick = localdbf_mlesc($prev_rec_nick);
	$prev_rec_nick = $prev_rec_nick.'$z';
	$prev_rec = $localdbf_allrecs[$prev_rec_login]['PlayerTime'];
	$prev_rec = MwTimeToString($prev_rec);
	$prev_rec_fin = $localdbf_allrecs[$prev_rec_login]['PlayerFinish'];
	$prev_rec_gap = $localdbf_allrecs[$prev_rec_login]['PlayerTime']-$localdbf_allrecs[$login]['PlayerTime'];
	$prev_rec_gap = MwTimeToString($prev_rec_gap);
	$prev_rec_pos = $player_pos +1;
	$noprevrec = false;
	}
	if(!$nonextrec){
				$localdbf_recs_xml[$login]['msg'] .= sprintf(
					'<label textsize="2" sizen="8 2" posn="-9 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s."/>'
					.'<label textsize="2" sizen="33 2" posn="-1 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s"/>'
					.'<label textsize="2" sizen="5 2" posn="32 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s"/>'
					.'<label textsize="2" sizen="10 2" posn="37 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s"/>'
					.'<label textsize="2" sizen="8 2" posn="47 '.$line.' 0.02" halign="left" action="'.$action.'" text="'.$col[3].' %s"/>'
					,$next_rec_pos, $next_rec_nick, $next_rec_fin, $next_rec, $next_rec_gap);	 
	$line = $line - 2.5;
					}
	
				$localdbf_recs_xml[$login]['msg'] .= sprintf(
					'<label textsize="2" sizen="8 2" posn="-9 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s."/>'
					.'<label textsize="2" sizen="33 2" posn="-1 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s"/>'
					.'<label textsize="2" sizen="5 2" posn="32 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s"/>'
					.'<label textsize="2" sizen="10 2" posn="37 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s"/>'
					,$player_pos, $player_nick, $player_fin, $player_rec);
	$line = $line - 2.5;
	
	if(!$noprevrec){
				$localdbf_recs_xml[$login]['msg'] .= sprintf(
					'<label textsize="2" sizen="8 2" posn="-9 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s."/>'
					.'<label textsize="2" sizen="33 2" posn="-1 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s"/>'
					.'<label textsize="2" sizen="5 2" posn="32 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s"/>'
					.'<label textsize="2" sizen="10 2" posn="37 '.$line.' 0.02" halign="left" action="'.$action.'" text=" %s"/>'
					.'<label textsize="2" sizen="8 2" posn="47 '.$line.' 0.02" halign="left" action="'.$action.'" text="'.$col[4].' %s"/>'
					,$prev_rec_pos, $prev_rec_nick, $prev_rec_fin, $prev_rec, $prev_rec_gap);
				   }
	} // only if you got a rec on track
	
								 
		$localdbf_recs_xml[$login]['msg'] .= localdbf_ml_gui('PageNavi',array($currentpage, $maxpage),
										array($_ml_act['localdbf_recs.back'], $_ml_act['localdbf_recs.next'], $_ml_act['localdbf_recs.open']),
										array(40,1,2));
								 							
	$localdbf_recs_xml[$login]['msg'] .= sprintf('</frame>');
}

function localdbfUpdateRecsXml($login,$action='show'){
	global $_mldebug,$_players,$localdbf_recs_xml;
	// if the players disabled manialinks then do nothing
	if(!isset($_players[$login]['ML']['ShowML']) || $_players[$login]['ML']['ShowML']<=0)
		return;
	$status = $_players[$login]['Status'];
	if($_mldebug>3) console("localdbfUpdateRecsXml('$login',$action) - $status");

	if($action=='remove'){
		// remove manialink
		manialinksRemove($login,'localdbf_recs');
		return;

	}elseif($action=='hide'){
		// hide manialink
		manialinksHide($login,'localdbf_recs');
		return;

	}elseif($action=='refresh' && !manialinksIsOpened($login,'localdbf_recs')){
		// refresh but not opened: do nothing
		return;
	}

	// show/refresh
	$xml = sprintf($localdbf_recs_xml[$login]['msg'],-24,40,72);
		manialinksShow($login,'localdbf_recs',$xml);
}
//[Rounds(0), TimeAttack(1), Team(2), Laps(3), Stunts(4), Cup(5)]'; $_GameInfos[GameMode];
// returns the string to implemet some basic navigation
// $item = guiitem $action=ml.actions $label=text $pos=position inframe
function localdbf_ml_gui($item, $label, $action, $pos)
{		global $_ml_act;
	
	if($item == 'PageNavi')
	{
	$pos[3]=$pos[0]-3; $pos[4]=$pos[1]+1; $pos[5]=$pos[2]-1;
	$pos[6]=$pos[0]+7; $pos[7]=$pos[1]+0.5; $pos[8]=$pos[2];
	$pos[9]=$pos[0]+11; $pos[10]=$pos[1]+0.5; $pos[11]=$pos[2];
	$pos[12]=$pos[0]+15; $pos[13]=$pos[1]+0.5; $pos[14]=$pos[2];
	$pos[15]=$pos[0]-2;
	$localdbf_ml_gui = sprintf('<label posn="'.$pos[15].' '.$pos[1].' '.$pos[2].'" style="TextButtonSmall" text="'.$label[0].' / '.$label[1].'"/>'
				 .'<quad posn="'.$pos[3].' '.$pos[4].' '.$pos[5].'" sizen="22 4" style="Bgs1InRace" substyle="BgButtonBig" />'
				 .'<quad posn="'.$pos[6].' '.$pos[7].' '.$pos[8].'" sizen="3 3" style="Icons64x64_1" substyle="ArrowPrev" action = "'.$action[0].'"/>'
				 .'<quad posn="'.$pos[9].' '.$pos[10].' '.$pos[11].'" sizen="3 3" style="Icons64x64_1" substyle="ArrowNext" action = "'.$action[1].'"/>'
				 .'<quad posn="'.$pos[12].' '.$pos[13].' '.$pos[14].'" sizen="3 3" style="Icons64x64_1" substyle="Close" action = "'.$action[2].'"/>');	
				 				 
	return($localdbf_ml_gui);	
	}

	if($item == 'PageClose')
	{
	$pos[3]=$pos[0]+0.5; $pos[4]=$pos[1]-0.5; $pos[5]=$pos[2]+0.1;
	$localdbf_ml_gui = sprintf(
	 '<quad posn="'.$pos[0].' '.$pos[1].' '.$pos[2].'" sizen="4 4" style="Bgs1InRace" substyle="BgButtonBig" />'
	.'<quad posn="'.$pos[3].' '.$pos[4].' '.$pos[5].'" sizen="3 3" style="Icons64x64_1" substyle="Close" action = "'.$action[0].'"/>');
	return($localdbf_ml_gui);
	}
}

//************* responses from the users *******************//
function localdbfPlayerManialinkPageAnswer($event,$login,$answer,$action){
	global $_mldebug, $_ChallengeList, $_players, $localdbf_players, $localdbf_allranks, 
			$localdbf_top_xml, $localdbf_recs, $localdbf_recs_xml, $_mlmenus;
	
	//for debug
	//print_r($event.'       '.$login.'   '.$answer.'   '.$action);
		
	//switch the recordspannel
	if($action=='localdbf_main.up' && $localdbf_players[$login]['ShowRecs'] < 4){
		$localdbf_players[$login]['ShowRecs']++;
		localdbfBuildMainXml($login);
		localdbfUpdateMainXml($login,'refresh');
	}
	elseif($action=='localdbf_main.down' && $localdbf_players[$login]['ShowRecs'] > 1){
		$localdbf_players[$login]['ShowRecs']--;
		localdbfBuildMainXml($login);
		localdbfUpdateMainXml($login,'refresh');
	}
	elseif($action=='localdbf_main.down' && $localdbf_players[$login]['ShowRecs'] == 1){
	}
	// open top window
	elseif($action=='localdbf_top.open' && !manialinksIsOpened($login,'localdbf_top')){
	 	$localdbf_top_xml[$login]['idx'] = 0;
	 	localdbfBuildTopXml($login);
		localdbfUpdateTopXml($login,'show');}

	// close top window if already open
	elseif($action=='localdbf_top.open' && manialinksIsOpened($login,'localdbf_top')){
		localdbfUpdateTopXml($login,'remove');
		$localdbf_top_xml[$login]['idx'] = 0;}
	// browse the top forward
	elseif($action=='localdbf_top.next'){
	 	$counter = count($localdbf_allranks);
	 	if($localdbf_top_xml[$login]['idx']+20 < $counter ) {$localdbf_top_xml[$login]['idx'] = $localdbf_top_xml[$login]['idx'] + 20;}
		localdbfBuildTopXml($login,'show');
		localdbfUpdateTopXml($login,'refresh');}
	// browse the top backward
	elseif($action=='localdbf_top.back'){
	 	if($localdbf_top_xml[$login]['idx'] > 0 ) $localdbf_top_xml[$login]['idx'] = $localdbf_top_xml[$login]['idx'] - 20;
		localdbfBuildTopXml($login,'show');
		localdbfUpdateTopXml($login,'refresh');}
// open recs window
	elseif($action=='localdbf_recs.open' && !manialinksIsOpened($login,'localdbf_recs')){
	 	$localdbf_recs_xml[$login]['idx'] = 0;
	 	localdbfBuildRecsXml($login);
		localdbfUpdateRecsXml($login,'show');}

	// close recs window if already open
	elseif($action=='localdbf_recs.open' && manialinksIsOpened($login,'localdbf_recs')){
		localdbfUpdateRecsXml($login,'hide');
		$localdbf_recs_xml[$login]['idx'] = 0;}
	// browse the recs forward
	elseif($action=='localdbf_recs.next'){
	 	$counter = count($localdbf_recs);
	 	if($localdbf_recs_xml[$login]['idx']+20 < $counter ) {$localdbf_recs_xml[$login]['idx'] = $localdbf_recs_xml[$login]['idx'] + 20;}
		localdbfBuildRecsXml($login,'show');
		localdbfUpdateRecsXml($login,'refresh');}
	// browse the recs backward
	elseif($action=='localdbf_recs.back'){
	 	if($localdbf_recs_xml[$login]['idx'] > 0 ) $localdbf_recs_xml[$login]['idx'] = $localdbf_recs_xml[$login]['idx'] - 20;
		localdbfBuildRecsXml($login,'show');
		localdbfUpdateRecsXml($login,'refresh');}
	// save settings after confirmation
	elseif($action=='localdbf_confirm.yes'){
		localdbf_confirm($login,'remove');
		localdbf_saveconfig();		
	}
	// close the confirmation window do nuttin
	elseif($action=='localdbf_confirm.no'){
		localdbf_confirm($login,'remove');	
	}
	// open the menu
	elseif($action=='localdbf_admin.open'){
	 	if(function_exists('saInit'))
			ml_menusShowMenu($login,'menu.gmenu','menu.localdbf');
			else
			ml_menusShowMenu($login,'menu.mmenu','menu.localdbf');
	}	
}

// the menu thing
//--------------------------------------------------------------
// PlayerMenuBuild : (event from ml_menu plugin)
//--------------------------------------------------------------
function localdbfPlayerMenuBuild($event,$login){
	global $_mldebug, $localdbf_config, $_mlmenus, $localdbf_players, $_locale, $localdbf_is_glider;
	if($_mldebug>0) console("localdbfPlayerMenuBuild.Event[$event]('$login')");
	
	$txt_menumain = localeText($login,'localdbf.menumain');
	$txt_menurecords = localeText($login,'localdbf.menurecords');
	$txt_menulanguage = localeText($login,'localdbf.menulanguage');
	$txt_menumaintain = localeText($login,'localdbf.menumaintain');
	$txt_menusavecfg = localeText($login,'localdbf.menusaveconfig');
	$txt_menushowrecson = localeText($login,'localdbf.menushowrecson');
	$txt_menushowrecsoff = localeText($login,'localdbf.menushowrecsoff');
	$txt_menujoinmsgon = localeText($login,'localdbf.menujoinmsgon');
	$txt_menujoinmsgoff = localeText($login,'localdbf.menujoinmsgoff');
	$txt_showinfoall = localeText($login,'localdbf.menushowinfoall');
	$txt_showinfopb = localeText($login,'localdbf.menushowinfopb');
	$txt_menumaxtop = localeText($login,'localdbf.menumaxtop');
	$txt_menumaxtop_current = ' ('.$localdbf_config['maxtop'].')';
	$txt_defshowrecs = localeText($login,'localdbf.menudefshowrecs');
	$txt_defshowrecs_current = ' ('.$localdbf_config['defshowrecs'].')';
	$txt_menustats = localeText($login,'localdbf.menustats');
	$txt_forceshowrecson = localeText($login,'localdbf.menuforcerecson');
	$txt_forceshowrecsoff = localeText($login,'localdbf.menuforcerecsoff');
	$txt_forceshowrecsmax = localeText($login,'localdbf.menuforcerecsmax');
	$txt_forceshowrecsmax_current = ' ('.$localdbf_config['forceshowrecsmax'].')';
	
	if($localdbf_players[$login]['ShowRecs'] > 0) $showrecs_value = true;
	else $showrecs_value = false;
	if($localdbf_players[$login]['ShowInfo'] == 21 || $localdbf_players[$login]['ShowInfo'] == 22) $joinmsg_value = true;
	else $joinmsg_value = false;
	if($localdbf_players[$login]['ShowInfo'] == 22 || $localdbf_players[$login]['ShowInfo'] == 12){
	$allrecs_value = array(1 => $txt_showinfoall, 2 =>$txt_showinfopb);
	}
	else{
	$allrecs_value = array(1 => $txt_showinfopb, 2 =>$txt_showinfoall);
	}
	
	// check for gliders plugin pack for menu colaboration
	if($localdbf_is_glider === false){
	$menuitem = array('Name'=> $txt_menumain,'Menu'=>array('DefaultStyles'=>true,'Width'=>13,'Items'=>array()));
	ml_menusAddItem($login,'menu.main','menu.mmenu',$menuitem);
	}
	// add the local record submenu
	$menu_localdbf = array('Name'=> $txt_menurecords,'Menu'=>array('DefaultStyles'=>true,'Width'=>20,'Items'=>array()));
	// the maintainance submenu
	$menu_localdbf_maintain = array('Name'=> $txt_menumaintain,'Menu'=>array('DefaultStyles'=>true,'Width'=>20,'Items'=>array()));
	// the language selection
	$menu_localdbf_language = array('Name'=> $txt_menulanguage,'Menu'=>array('DefaultStyles'=>true,'Width'=>6,'Items'=>array()));
	// the maintainance items
	// adjust maxtop
	$menu_localdbf_maintain['Menu']['Items']['localdbf.maintain.maxtop'] = array(
	'Name'=>array(
	$txt_menumaxtop.'100'.$txt_menumaxtop_current,$txt_menumaxtop.'75'.$txt_menumaxtop_current,
	$txt_menumaxtop.'50'.$txt_menumaxtop_current,$txt_menumaxtop.'30'.$txt_menumaxtop_current,
	$txt_menumaxtop.'25'.$txt_menumaxtop_current,$txt_menumaxtop.'20'.$txt_menumaxtop_current,
	$txt_menumaxtop.'10'.$txt_menumaxtop_current,$txt_menumaxtop.'5'.$txt_menumaxtop_current),'Type'=>'multi');
	// adjust default records to show in panel
	$menu_localdbf_maintain['Menu']['Items']['localdbf.maintain.defshowrecs'] = array(
	'Name'=>array(
	$txt_defshowrecs.'3'.$txt_defshowrecs_current,$txt_defshowrecs.'5'.$txt_defshowrecs_current,
	$txt_defshowrecs.'10'.$txt_defshowrecs_current,$txt_defshowrecs.'1'.$txt_defshowrecs_current),'Type'=>'multi');
	// force show localrecords to all
	$menu_localdbf_maintain['Menu']['Items']['localdbf.maintain.forceshowrecs'] = array(
	'Name'=>array($txt_forceshowrecson,$txt_forceshowrecsoff),'Type'=>'bool','State'=>false);
	// force show howmany localrecsords to all
	$menu_localdbf_maintain['Menu']['Items']['localdbf.maintain.forceshowrecsmax'] = array(
	'Name'=>array(
	$txt_forceshowrecsmax.'100'.$txt_forceshowrecsmax_current, $txt_forceshowrecsmax.'75'.$txt_forceshowrecsmax_current, 
	$txt_forceshowrecsmax.'50'.$txt_forceshowrecsmax_current, $txt_forceshowrecsmax.'30'.$txt_forceshowrecsmax_current, 
	$txt_forceshowrecsmax.'25'.$txt_forceshowrecsmax_current, $txt_forceshowrecsmax.'10'.$txt_forceshowrecsmax_current,
	$txt_forceshowrecsmax.'5'.$txt_forceshowrecsmax_current, $txt_forceshowrecsmax.'3'.$txt_forceshowrecsmax_current, 
	$txt_forceshowrecsmax.'1'.$txt_forceshowrecsmax_current),'Type'=>'multi');
	// save the settings
	$menu_localdbf_maintain['Menu']['Items']['localdbf.maintain.saveconfig'] = array('Name'=> $txt_menusavecfg,'Type'=>'item');
	
	//add maintainance submenu to admins
	if(verifyAdmin($login))
	$menu_localdbf['Menu']['Items']['localdbf.maintain'] = $menu_localdbf_maintain;
	//add other playeritems
	$menu_localdbf['Menu']['Items']['localdbf.showrecs'] = array('Name'=>array($txt_menushowrecson,$txt_menushowrecsoff),'Type'=>'bool','State'=>true);
	$menu_localdbf['Menu']['Items']['localdbf.joinmsg'] = array('Name'=>array($txt_menujoinmsgon,$txt_menujoinmsgoff),'Type'=>'bool','State'=>true);
	$menu_localdbf['Menu']['Items']['localdbf.showinfo'] = array('Name'=>array($allrecs_value[1],$allrecs_value[2]),'Type'=>'multi');
	$menu_localdbf['Menu']['Items']['localdbf.showstats'] = array('Name' => $txt_menustats,'Type'=>'item');
	//add the language selection options
	foreach($_locale as $k=>$v){
			$language = $k;
			$action = 'localdbf.language.'.$k;
			$name = strtoupper($k);
			$menu_localdbf_language['Menu']['Items'][$action] = array('Name'=>$name, 'Type'=>'item');
	}
	//add the language menu to the localdbf menu
	$menu_localdbf['Menu']['Items']['localdbf.language'] = $menu_localdbf_language;
	
	//insert the local records submanu into parent menu
	if($localdbf_is_glider === true)
	ml_menusAddItem($login, 'menu.gmenu', 'menu.localdbf', $menu_localdbf);
	else
	ml_menusAddItem($login, 'menu.mmenu', 'menu.localdbf', $menu_localdbf);

}


//--------------------------------------------------------------
// PlayerMenuAction : (event from ml_menus plugin)
//--------------------------------------------------------------
function localdbfPlayerMenuAction($event,$login,$action,$state){
	global $_mldebug, $localdbf_players, $localdbf_config, $localdbf_maxtop, $_players;
	if($_mldebug>0) console("localdbfPlayerMenuAction.Event[$event]('$login',$action,$state)");
	
	// disable the local record display
	if($action=='localdbf.showrecs' && $state != 1){
		localdbfUpdateMainXml($login,'hide');
		$localdbf_players[$login]['OldShowRecs'] = $localdbf_players[$login]['ShowRecs'];
		$localdbf_players[$login]['ShowRecs'] = 0;
	}
	// enable the local record display
	elseif($action=='localdbf.showrecs' && $state == 1){
		if($localdbf_players[$login]['OldShowRecs'] == 0) $localdbf_players[$login]['OldShowRecs'] = 2;
		$localdbf_players[$login]['ShowRecs'] = $localdbf_players[$login]['OldShowRecs'];
		localdbfUpdateMainXml($login,'show');
	}
	// security question before saving config
	elseif($action=='localdbf.maintain.saveconfig' && !manialinksIsOpened($login,'localdbf_confirm')){
		localdbf_confirm($login,'show');
	}
	// adjust the maxtop value
	elseif($action=='localdbf.maintain.maxtop'){
	 	switch($state){
		case 0: $localdbf_config['maxtop'] = 100; break;
		case 1: $localdbf_config['maxtop'] = 75; break;
		case 2: $localdbf_config['maxtop'] = 50; break;
		case 3: $localdbf_config['maxtop'] = 30; break;
		case 4: $localdbf_config['maxtop'] = 25; break;
		case 5: $localdbf_config['maxtop'] = 20; break;
		case 6: $localdbf_config['maxtop'] = 10; break;
		case 7: $localdbf_config['maxtop'] = 5; break;
		}
	}
	// adjust default amount of records to show 1=1rec, 2=3recs, 3=5recs, 4=10recs
	elseif($action=='localdbf.maintain.defshowrecs'){
		switch($state){
		case 0: $localdbf_config['defshowrecs'] = 3; break;
		case 1: $localdbf_config['defshowrecs'] = 5; break;
		case 2: $localdbf_config['defshowrecs'] = 10; break;
		case 3: $localdbf_config['defshowrecs'] = 1; break;
		}		
	}
	// show join message
	elseif($action=='localdbf.joinmsg'){
		if($state == 1){
			$showinfo = $localdbf_players[$login]['ShowInfo'];
			if($showinfo == 12) $showinfo = 22;
			elseif($showinfo == 11) $showinfo = 21;
			$localdbf_players[$login]['ShowInfo'] = $showinfo;	
		}
		else{
			$showinfo = $localdbf_players[$login]['ShowInfo'];
			if($showinfo == 21) $showinfo = 11;
			elseif($showinfo == 22) $showinfo = 12;
			$localdbf_players[$login]['ShowInfo'] = $showinfo;
		}
	}
	// show allrecs in chat
	elseif($action=='localdbf.showinfo'){
		$showinfo = $localdbf_players[$login]['ShowInfo'];
		
			if($showinfo == 12) $showinfo = 11;
			elseif($showinfo == 22) $showinfo = 21;
			elseif($showinfo == 21) $showinfo = 22;
			elseif($showinfo == 11) $showinfo = 12;
			
			$localdbf_players[$login]['ShowInfo'] = $showinfo;	
	}
	// set the language
	elseif(strstr($action,'localdbf.language.')){
		$language = substr($action,18);
		if($_players[$login]['Language'] != $language){
				$_players[$login]['Language'] = $language;
				$localdbf_players[$login]['Nation'] = $language;
				addEvent('PlayerShowML',$login,false);
				addEvent('PlayerShowML',$login,true);
				localdbfBuildMainXml($login);
				addEvent('PlayerMenuAction',$login,'localdbf.showrecs',0);
				addEvent('PlayerMenuAction',$login,'localdbf.showrecs',1);
			}
	}
	// force show recs in chat on or off
	elseif($action=='localdbf.maintain.forceshowrecs'){
		if($localdbf_config['forceshowrecs'] == 0) $localdbf_config['forceshowrecs'] = 1;
			else $localdbf_config['forceshowrecs'] = 0 ;
	
	}
	// adjust force show recs to all
	elseif($action=='localdbf.maintain.forceshowrecsmax'){
	 	switch($state){
		case 0: $localdbf_config['forceshowrecsmax'] = 100; break;
		case 1: $localdbf_config['forceshowrecsmax'] = 75; break;
		case 2: $localdbf_config['forceshowrecsmax'] = 50; break;
		case 3: $localdbf_config['forceshowrecsmax'] = 30; break;
		case 4: $localdbf_config['forceshowrecsmax'] = 25; break;
		case 5: $localdbf_config['forceshowrecsmax'] = 10; break;
		case 6: $localdbf_config['forceshowrecsmax'] = 5; break;
		case 7: $localdbf_config['forceshowrecsmax'] = 3; break;
		case 8: $localdbf_config['forceshowrecsmax'] = 1; break;
		}
	}
	// show your stats
	elseif($action=='localdbf.showstats'){
		localdbfAnnouncePlayer($login,'stats');
	}
}

function localdbf_sendmsg_toall($login,$msg)
{	global $_players, $localdbf_players, $localdbf_config;

 	foreach($_players as $player){
 		$playerlogin = $player['Login'];
 		// Showinfo -> first value joinmsg (1=off, 2=on) -> second value showallchatrecs (1=off, 2=on)
 		if($localdbf_players[$playerlogin]['ShowInfo'] == 12 || $localdbf_players[$playerlogin]['ShowInfo'] == 22)
 			$showallrecs = true;
 		else
 			$showallrecs = false;
 		
 		if($localdbf_config['forceshowrecs'] == 1 && $msg[4] <= $localdbf_config['forceshowrecsmax'])
 			$showallrecs = true;
 		
		 if($showallrecs && $playerlogin != $login){
		 $message = localeText($playerlogin,$msg[1]).localeText($playerlogin,$msg[2],$msg[3],$msg[4],$msg[5]);		
 		 addCall(null,"ChatSendServerMessageToLogin", $message, $playerlogin);
 		 }
	}
}
function localdbf_confirm($login,$action='show'){
	global $_ml_act,$_players;
	
	$txt_confirm = localeText($login,'localdbf.confirm');
	$txt_confirm_yes = localeText($login,'localdbf.confirm.yes');
	$txt_confirm_no = localeText($login,'localdbf.confirm.no');
	
	if(!isset($_players[$login]['ML']['ShowML'])||$_players[$login]['ML']['ShowML']<=0)
		return;
	if($action=='remove'){
		manialinksRemove($login,'localdbf_confirm');
		return;
	}elseif($action=='hide'){
		manialinksHide($login,'localdbf_confirm');
		return;
	}elseif($action=='refresh'&&!manialinksIsOpened($login,'localdbf_confirm'))
		return;
	$xml='<frame posn="0 10 5"><quad  sizen="70 15" posn="0 0 0" halign="center" valign="center" style="Bgs1" substyle="BgWindow2"/>
		  <quad  sizen="67 5" posn="0 3 0.1" halign="center" valign="center" style="Bgs1" substyle="BgTitle2"/>
		  <label sizen="60 3" posn="0 3 0.11" halign="center" valign="center" style="TextTitle2" text="'.$txt_confirm.'"/>
		  <label posn="-14 -2 0.1" halign="center" style="CardButtonSmall" action="'.$_ml_act['localdbf_confirm.yes'].'" text="'.$txt_confirm_yes.'"/>
		  <label posn="14 -2 0.1" halign="center" style="CardButtonSmall" action="'.$_ml_act['localdbf_confirm.no'].'" text="'.$txt_confirm_no.'"/>
		  </frame>';
	manialinksShow($login,'localdbf_confirm',$xml);
}
?>
